diff --git a/hubs/static/client/app/components/feed/ItemsGetter.js b/hubs/static/client/app/components/feed/ItemsGetter.js
new file mode 100644
index 0000000..ff0fb0e
--- /dev/null
+++ b/hubs/static/client/app/components/feed/ItemsGetter.js
@@ -0,0 +1,121 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import Spinner from "../Spinner";
+
+
+class ItemsGetter extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      isLoading: false,
+      errorMessage: null,
+    };
+    this.loadFromServer = this.loadFromServer.bind(this);
+    this.showErrorMessage = this.showErrorMessage.bind(this);
+    this.errorTimeout = null;
+  }
+
+  componentDidMount() {
+    this.loadFromServer();
+  }
+
+  componentWillUnmount() {
+    this.serverRequest.abort();
+  }
+
+  componentDidUpdate(prevProps, prevState) {
+    if (this.props.needsUpdate && !this.state.isLoading) {
+      this.loadFromServer();
+    }
+    if (this.props.useSSE) {
+      if (this.props.sseConnected && this.state.errorMessage) {
+        // Reconnected
+        if (this.errorTimeout) {
+          window.clearTimeout(this.errorTimeout);
+        }
+        this.setState({errorMessage: null});
+      } else if (!this.state.errorMessage && !this.props.sseConnected) {
+        // Disconnected
+        this.errorTimeout = window.setTimeout(this.showErrorMessage, 3000);
+      }
+    }
+  }
+
+  loadFromServer() {
+    if (this.props.onRequestStart) {
+      this.props.onRequestStart();
+    }
+    this.setState({isLoading: true});
+    if (this.serverRequest &&
+        this.serverRequest.readyState !== XMLHttpRequest.DONE) {
+      this.serverRequest.abort();
+    }
+    this.serverRequest = $.ajax({
+      url: this.props.url,
+      method: 'GET',
+      dataType: 'json',
+      cache: false,
+      success: (data, textStatus, jqXHR) => {
+        this.props.handleData(data.data);
+      },
+      error: (xhr, status, err) => {
+        console.error(status, err.toString());
+      },
+      complete: (xhr, status) => {
+        this.setState({isLoading: false});
+      },
+    });
+  }
+
+  showErrorMessage() {
+    let msg = null;
+    switch (this.props.sseReadyState) {
+      case 2:
+        msg = (
+          "Cannot auto-update the feed, you will have to refresh " +
+          "the page manually to see new elements."
+        );
+      case 0:
+        msg = (
+          "Reconnecting to the auto-update source..."
+        );
+    }
+    this.setState({errorMessage: msg});
+  }
+
+  render() {
+    return (
+      <div className="ItemsGetter">
+        {this.props.children}
+        { this.state.isLoading &&
+          <Spinner />
+        }
+        { this.state.errorMessage &&
+          <div className="alert alert-warning mt-3 mb-0">
+            {this.state.errorMessage}
+          </div>
+        }
+      </div>
+    );
+  }
+}
+ItemsGetter.propTypes = {
+  useSSE: PropTypes.bool,
+  needsUpdate: PropTypes.bool,
+}
+ItemsGetter.defaultProps = {
+  useSSE: false,
+  needsUpdate: false,
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    sseConnected: state.sse.connected,
+    sseReadyState: state.sse.readyState,
+  }
+};
+
+export default connect(mapStateToProps)(ItemsGetter);
diff --git a/hubs/static/client/app/components/feed/Markup.js b/hubs/static/client/app/components/feed/Markup.js
new file mode 100644
index 0000000..f5a50f2
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Markup.js
@@ -0,0 +1,50 @@
+import React from 'react';
+import TimeAgo from 'react-timeago';
+
+
+export default class Markup extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.createMarkup = this.createMarkup.bind(this);
+  }
+
+  createMarkup(item) {
+    return { __html: item.markup || item.subtitle };
+  }
+
+  render() {
+    const timestamp = this.props.item.end_time || this.props.item.timestamp;
+    const submsgs = this.props.item.msg_ids;
+    var submessages = [];
+    if (submsgs && Object.keys(submsgs).length > 1) {
+      submessages = Object.keys(submsgs).map((msgid) => {
+        return (
+          <li key={msgid}>
+            <small dangerouslySetInnerHTML={this.createMarkup(submsgs[msgid])}></small>
+          </li>
+        );
+      });
+    }
+
+    return (
+      <div className="media-body align-self-start">
+        <span dangerouslySetInnerHTML={this.createMarkup(this.props.item)}></span>
+        {timestamp &&
+          <small className="text-muted ml-3">
+            <TimeAgo date={timestamp * 1000} />
+          </small>
+        }
+        {submessages.length !== 0 &&
+          <ul
+            className="submessages"
+            style={{display: this.props.detailsOpened ? "block" : "none" }}
+            >
+            {submessages}
+          </ul>
+        }
+      </div>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/components/feed/Panel.js b/hubs/static/client/app/components/feed/Panel.js
new file mode 100644
index 0000000..2dcee5b
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Panel.js
@@ -0,0 +1,49 @@
+import React from 'react';
+import Icon from './Icon';
+import Markup from './Markup';
+import Actions from './Actions';
+
+
+export default class Panel extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      detailsOpened: false,
+    }
+    this.toggleDetails = this.toggleDetails.bind(this);
+  }
+
+  toggleDetails(e) {
+    e.preventDefault();
+    this.setState((prevState, props) => (
+      {detailsOpened: !prevState.detailsOpened}
+    ));
+  }
+
+  render() {
+    return (
+      <div className="media py-3" id={this.props.item.id}>
+        <Icon item={this.props.item} />
+        <Markup
+          {...this.props}
+          detailsOpened={this.state.detailsOpened}
+          />
+        <div className="d-flex flex-column align-self-start ml-3 text-right">
+          { (this.props.handleSave || this.props.handleUnsave) &&
+            <Actions {...this.props} />
+          }
+          { (this.props.item.msg_ids &&
+             Object.keys(this.props.item.msg_ids).length > 1) &&
+            <div className="mt-auto">
+              <small>
+                <a href="#" onClick={this.toggleDetails}>details</a>
+              </small>
+            </div>
+          }
+        </div>
+      </div>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/components/feed/__tests__/Feed.test.js b/hubs/static/client/app/components/feed/__tests__/Feed.test.js
index 9f2e9be..501da7f 100644
--- a/hubs/static/client/app/components/feed/__tests__/Feed.test.js
+++ b/hubs/static/client/app/components/feed/__tests__/Feed.test.js
@@ -1,13 +1,13 @@
 /* eslint-env jasmine, jest */
 
-jest.unmock('../Feed.jsx');
-
 import React from 'react';
 import ReactDOM from 'react-dom';
-import TestUtils from 'react-addons-test-utils';
+import {mount} from 'enzyme';
+
+import Feed from '../Feed';
 
-import Feed from '../Feed.jsx';
-import Panel from '../Panel.jsx';
+jest.mock("../Panel");
+import Panel from '../Panel';
 
 describe('Feed', () => {
   const item = {
@@ -22,13 +22,9 @@ describe('Feed', () => {
   });
 
   it('should create the children', () => {
-    const component = TestUtils.renderIntoDocument(
+    const component = mount(
       <Feed items={items} />
     );
-    const node = ReactDOM.findDOMNode(component);
     expect(Panel.mock.calls.length).toEqual(3);
   });
 });
-
-
-// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/__tests__/Icon.test.js b/hubs/static/client/app/components/feed/__tests__/Icon.test.js
index 3cd5bb8..fe1c3cd 100644
--- a/hubs/static/client/app/components/feed/__tests__/Icon.test.js
+++ b/hubs/static/client/app/components/feed/__tests__/Icon.test.js
@@ -1,12 +1,9 @@
 /* eslint-env jasmine, jest */
 
-jest.unmock('../Icon.jsx');
-
 import React from 'react';
-import ReactDOM from 'react-dom';
-import TestUtils from 'react-addons-test-utils';
+import {shallow} from 'enzyme';
 
-import Icon from '../Icon.jsx';
+import Icon from '../Icon';
 
 describe('Icon', () => {
   const item = {
@@ -15,24 +12,17 @@ describe('Icon', () => {
   };
 
   it('has the correct link', () => {
-    const component = TestUtils.renderIntoDocument(
+    const component = shallow(
       <Icon item={item} />
     );
     expect(component).toBeTruthy();
-    const node = ReactDOM.findDOMNode(component);
-    expect(node.getAttribute('href')).toEqual(item.link);
+    expect(component.find("a").prop('href')).toEqual(item.link);
   });
   it('has the correct image source', () => {
-    const component = TestUtils.renderIntoDocument(
+    const component = shallow(
       <Icon item={item} />
     );
     expect(component).toBeTruthy();
-
-    const node = ReactDOM.findDOMNode(component);
-    const image = node.querySelector('img');
-    expect(image.getAttribute('src')).toEqual(item.secondary_icon);
+    expect(component.find("img").prop('src')).toEqual(item.secondary_icon);
   });
 });
-
-
-// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/__tests__/Markup.test.js b/hubs/static/client/app/components/feed/__tests__/Markup.test.js
index 6305d51..97d9c93 100644
--- a/hubs/static/client/app/components/feed/__tests__/Markup.test.js
+++ b/hubs/static/client/app/components/feed/__tests__/Markup.test.js
@@ -1,12 +1,9 @@
 /* eslint-env jasmine, jest */
 
-jest.unmock('../Markup.jsx');
-
 import React from 'react';
-import ReactDOM from 'react-dom';
-import TestUtils from 'react-addons-test-utils';
+import {shallow} from 'enzyme';
 
-import Markup from '../Markup.jsx';
+import Markup from '../Markup';
 
 describe('Markup', () => {
   const item = {
@@ -15,19 +12,13 @@ describe('Markup', () => {
   };
 
   it('should set the inner html of the markup', () => {
-    const component = TestUtils.renderIntoDocument(
+    const component = shallow(
       <Markup item={item} />
     );
     expect(component).toBeTruthy();
-
-    const node = ReactDOM.findDOMNode(component);
-    const markup = node.querySelector('span');
-
-    expect(markup.innerHTML).toEqual(item.markup);
+    expect(component.find("span").html()).toEqual(
+      "<span>" + item.markup + "</span>");
   });
 
   // we don't test TimeAgo, the library should have its own tests
 });
-
-
-// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/__tests__/Panel.test.js b/hubs/static/client/app/components/feed/__tests__/Panel.test.js
index ff93dbe..abdea82 100644
--- a/hubs/static/client/app/components/feed/__tests__/Panel.test.js
+++ b/hubs/static/client/app/components/feed/__tests__/Panel.test.js
@@ -1,12 +1,9 @@
 /* eslint-env jasmine, jest */
 
-jest.unmock('../Panel.jsx');
-
 import React from 'react';
-import ReactDOM from 'react-dom';
-import TestUtils from 'react-addons-test-utils';
+import {shallow} from 'enzyme';
 
-import Panel from '../Panel.jsx';
+import Panel from '../Panel';
 
 describe('Panel', () => {
   const item = {
@@ -21,29 +18,25 @@ describe('Panel', () => {
   };
 
   it('should render the actions block', () => {
-    const component = TestUtils.renderIntoDocument(
-      <Panel item={item} />
+    let node;
+    const component = shallow(
+      <Panel item={item} ref={(el) => {node = el; }} />
     );
     expect(component).toBeTruthy();
 
-    const node = ReactDOM.findDOMNode(component);
-    const block = node.querySelector('div.ml-3.text-right');
-
-    expect(block).toBeTruthy();
+    //const block = node.querySelector('div.ml-3.text-right');
+    expect(component.find("div.ml-3.text-right")).toBeTruthy();
   });
 
   it('should show the details link', () => {
-    const component = TestUtils.renderIntoDocument(
-      <Panel item={item} />
+    let node;
+    const component = shallow(
+      <Panel item={item} ref={(el) => {node = el; }} />
     );
     expect(component).toBeTruthy();
 
-    const node = ReactDOM.findDOMNode(component);
-    const details = node.querySelector('.text-right small a');
+    //const details = node.querySelector('.text-right small a');
 
-    expect(details).toBeTruthy();
+    expect(component.find(".text-right small a")).toBeTruthy();
   });
 });
-
-
-// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/core/App.js b/hubs/static/client/app/core/App.js
new file mode 100644
index 0000000..6c90b23
--- /dev/null
+++ b/hubs/static/client/app/core/App.js
@@ -0,0 +1,32 @@
+import React from 'react';
+import {
+  connect,
+  Provider
+  } from 'react-redux';
+import { IntlProvider } from 'react-intl';
+import * as Pages from "../core/Pages";
+
+
+const PageContainer = connect(
+  (state) => ({pageName: state.ui.page})
+)(
+  (props) => {
+    if (!Pages[props.pageName]) {
+      console.error("No such page: " + props.pageName + ". Choose one of:", Object.keys(Pages).join(", "));
+      return null;
+    }
+    return React.createElement(Pages[props.pageName], {});
+  }
+);
+
+
+const App = (props) => {
+  return (
+    <Provider store={props.store}>
+      <IntlProvider locale={navigator.language}>
+        <PageContainer />
+      </IntlProvider>
+    </Provider>
+  );
+}
+export default App;
diff --git a/hubs/static/client/app/core/Pages.js b/hubs/static/client/app/core/Pages.js
new file mode 100644
index 0000000..def36e4
--- /dev/null
+++ b/hubs/static/client/app/core/Pages.js
@@ -0,0 +1,26 @@
+import React from 'react';
+import {
+  makeLoadable,
+  makeLoadingComponent
+} from '../core/utils';
+
+
+const PageLoadingComponent = makeLoadingComponent(
+  "Loading...",
+  "Sorry, there was a problem loading the page."
+);
+
+
+let Hub = makeLoadable(
+  () => import(/* webpackChunkName: "page-hub" */ '../components/HubPage'),
+  PageLoadingComponent
+);
+let Streams = makeLoadable(
+  () => import(/* webpackChunkName: "page-streams" */ '../components/StreamsPage'),
+  PageLoadingComponent
+);
+
+//Hub = require('../components/HubPage').default;
+//Streams = require('../components/StreamsPage').default;
+
+export {Hub, Streams};
diff --git a/hubs/static/client/app/core/actions/flashMessages.js b/hubs/static/client/app/core/actions/flashMessages.js
new file mode 100644
index 0000000..2333032
--- /dev/null
+++ b/hubs/static/client/app/core/actions/flashMessages.js
@@ -0,0 +1,19 @@
+/*
+ * Messages
+ */
+
+export const ADD_FLASH_MESSAGE = "ADD_FLASH_MESSAGE";
+export function addFlashMessage(text, msgType) {
+  return {
+    type: ADD_FLASH_MESSAGE,
+    text, msgType
+  }
+}
+
+export const CLOSE_FLASH_MESSAGE = "CLOSE_FLASH_MESSAGE";
+export function closeFlashMessage(index) {
+  return {
+    type: CLOSE_FLASH_MESSAGE,
+    index
+  }
+}
diff --git a/hubs/static/client/app/core/actions/hub.js b/hubs/static/client/app/core/actions/hub.js
new file mode 100644
index 0000000..6099d2e
--- /dev/null
+++ b/hubs/static/client/app/core/actions/hub.js
@@ -0,0 +1,81 @@
+import { apiCall } from '../utils';
+import { addFlashMessage } from './flashMessages';
+
+
+/* GET */
+
+export const HUB_FETCH_REQUEST = 'HUB_FETCH_REQUEST';
+export const HUB_FETCH_SUCCESS = 'HUB_FETCH_SUCCESS';
+export const HUB_FETCH_FAILURE = 'HUB_FETCH_FAILURE';
+
+function requestHub() {
+  return {
+    type: HUB_FETCH_REQUEST,
+  }
+}
+
+function receiveHub(hub) {
+  return {
+    type: HUB_FETCH_SUCCESS,
+    hub: hub,
+    receivedAt: Date.now()
+  }
+}
+
+function hubRequestFailed() {
+  return {
+    type: HUB_FETCH_FAILURE,
+  }
+}
+
+export function fetchHub() {
+  return (dispatch, getState) => {
+    let url = getState().urls.hubConfig;
+    dispatch(requestHub());
+    return apiCall(url).then(
+      hub => dispatch(receiveHub(hub)),
+      error => {
+        dispatch(addFlashMessage(error.message, "error"));
+        return hubRequestFailed();
+      }
+    );
+  }
+}
+
+
+/* PUT */
+
+export const HUB_PUT_REQUEST = 'HUB_PUT_REQUEST';
+export const HUB_PUT_FAILURE = 'HUB_PUT_FAILURE';
+
+function putHub(config, users) {
+  return {
+    type: HUB_PUT_REQUEST,
+    config, users
+  }
+}
+
+function putHubFailure(message) {
+  return {
+    type: HUB_PUT_FAILURE,
+    message
+  }
+}
+
+
+export function saveHub(config, users) {
+  return (dispatch, getState) => {
+    let url = getState().urls.hubConfig;
+    dispatch(putHub(config, users));
+    const body = JSON.stringify({config, users});
+    return apiCall(url, {method: "PUT", body}).then(
+      result => {
+        dispatch(addFlashMessage("Configuration updated", "success"));
+        return dispatch(fetchHub());
+      },
+      error => {
+        dispatch(addFlashMessage(error.message, "error"));
+        return putHubFailure(error.message);
+      })
+  }
+}
diff --git a/hubs/static/client/app/core/actions/sse.js b/hubs/static/client/app/core/actions/sse.js
new file mode 100644
index 0000000..6fc4a66
--- /dev/null
+++ b/hubs/static/client/app/core/actions/sse.js
@@ -0,0 +1,40 @@
+export const SSE_CONNECTED = 'SSE_CONNECTED';
+export const SSE_DISCONNECTED = 'SSE_DISCONNECTED';
+
+
+export function sseConnected(source) {
+  return {
+    type: SSE_CONNECTED,
+    readyState: source.readyState
+  };
+}
+
+export function sseDisconnected(source) {
+  return {
+    type: SSE_DISCONNECTED,
+    readyState: source.readyState
+  };
+}
+
+
+export const WIDGET_NEEDS_UPDATE = 'WIDGET_NEEDS_UPDATE';
+export const NEW_NOTIFICATION = 'NEW_NOTIFICATION';
+
+export function sseEvent(type, data) {
+  switch (type) {
+    case "hubs:widget-updated":
+      const widgetId = data;
+      return {
+        type: WIDGET_NEEDS_UPDATE,
+        widgetId,
+      };
+    case "hubs:new-notification":
+      // TODO: implement the reducers for this action
+      const username = data;
+      return {
+        type: NEW_NOTIFICATION,
+        username,
+      };
+  }
+}
+
diff --git a/hubs/static/client/app/core/actions/stream.js b/hubs/static/client/app/core/actions/stream.js
new file mode 100644
index 0000000..a8dc405
--- /dev/null
+++ b/hubs/static/client/app/core/actions/stream.js
@@ -0,0 +1,16 @@
+export const STREAM_WILL_UPDATE = 'STREAM_WILL_UPDATE';
+export const STREAM_DID_UPDATE = 'STREAM_DID_UPDATE';
+
+export function streamWillUpdate() {
+  // TODO: implement the reducers for this action
+  return {
+    type: STREAM_WILL_UPDATE,
+  };
+}
+
+export function streamDidUpdate() {
+  // TODO: implement the reducers for this action
+  return {
+    type: STREAM_DID_UPDATE,
+  };
+}
diff --git a/hubs/static/client/app/core/actions/widget.js b/hubs/static/client/app/core/actions/widget.js
new file mode 100644
index 0000000..e7784a4
--- /dev/null
+++ b/hubs/static/client/app/core/actions/widget.js
@@ -0,0 +1,204 @@
+import { apiCall } from '../utils';
+import { addFlashMessage } from './flashMessages';
+import { fetchWidgets } from "./widgets";
+
+
+/* Update status */
+
+export const WIDGET_WILL_UPDATE = 'WIDGET_WILL_UPDATE'
+export const WIDGET_DID_UPDATE = 'WIDGET_DID_UPDATE'
+
+export function widgetWillUpdate(widgetId) {
+  return {
+    type: WIDGET_WILL_UPDATE,
+    widgetId,
+    receivedAt: Date.now()
+  }
+}
+
+export function widgetDidUpdate(widgetId) {
+  return {
+    type: WIDGET_DID_UPDATE,
+    widgetId,
+    receivedAt: Date.now()
+  }
+}
+
+
+/* PUT config */
+
+export const WIDGET_PUT_REQUEST = 'WIDGET_PUT_REQUEST';
+export const WIDGET_PUT_SUCCESS = 'WIDGET_PUT_SUCCESS';
+export const WIDGET_PUT_FAILURE = 'WIDGET_PUT_FAILURE';
+
+function putConfigRequest(widgetId, config) {
+  return {
+    type: WIDGET_PUT_REQUEST,
+    widgetId, config
+  }
+}
+function putConfigSuccess(widgetId, widgetProps) {
+  return {
+    type: WIDGET_PUT_SUCCESS,
+    widgetId, widgetProps
+  }
+}
+function putConfigSucceeded(widgetId) {
+  return (dispatch, getState) => {
+    const state = getState();
+    let url = state.entities.widgets.byId[widgetId].selfUrl;
+    return apiCall(url).then(
+      (widgetProps) => (dispatch(putConfigSuccess(widgetId, widgetProps))),
+      error => (putConfigFailure(widgetId, error.message))
+    );
+  }
+}
+function putConfigFailure(widgetId, message) {
+  return {
+    type: WIDGET_PUT_FAILURE,
+    widgetId, message
+  }
+}
+
+export function saveConfig(widgetId, config) {
+  return (dispatch, getState) => {
+    let url = getState().entities.widgets.byId[widgetId].selfUrl;
+    dispatch(putConfigRequest(widgetId, config));
+    const body = JSON.stringify({config});
+    return apiCall(url, {method: "PUT", body}).then(
+      result => {
+        dispatch(addFlashMessage("Widget configuration changed.", "success"));
+        return dispatch(putConfigSucceeded(widgetId));
+      },
+      error => {
+        dispatch(addFlashMessage(error.message, "error"));
+        return putConfigFailure(error.message);
+      })
+  }
+}
+
+
+
+/* DELETE */
+
+export const WIDGET_DELETE_SUCCESS = 'WIDGET_DELETE_SUCCESS';
+
+function widgetDeleted(widgetId, config) {
+  return {
+    type: WIDGET_DELETE_SUCCESS,
+    widgetId,
+  }
+}
+
+export function deleteWidget(widgetId) {
+  return (dispatch, getState) => {
+    let url = getState().entities.widgets.byId[widgetId].selfUrl;
+    return apiCall(url, {method: "DELETE"}).then(
+      result => {
+        dispatch(addFlashMessage("Widget removed.", "success"));
+        return dispatch(widgetDeleted(widgetId));
+      },
+      error => {
+        return dispatch(addFlashMessage(error.message, "error"));
+      })
+  }
+}
+
+
+
+/* Create (POST) */
+
+export const HUB_WIDGETS_ADD_REQUEST = 'HUB_WIDGETS_ADD_REQUEST';
+export const HUB_WIDGETS_ADD_FAILURE = 'HUB_WIDGETS_ADD_FAILURE';
+
+function widgetAddRequest(name, config, position) {
+  return {
+    type: HUB_WIDGETS_ADD_REQUEST,
+    name, config, position
+  }
+}
+function widgetAddFailure(name, message) {
+  return {
+    type: HUB_WIDGETS_ADD_FAILURE,
+    name, message
+  }
+}
+
+
+export function addWidget(name, config, position) {
+  return (dispatch, getState) => {
+    const state = getState();
+    let url = state.urls.widgets;
+    dispatch(widgetAddRequest(name, config));
+    const body = JSON.stringify({name, config, position});
+    return apiCall(url, {method: "POST", body}).then(
+      result => {
+        dispatch(addFlashMessage("Widget added.", "success"));
+        return dispatch(fetchWidgets());
+      },
+      error => {
+        dispatch(addFlashMessage(error.message, "error"));
+        return widgetAddFailure(error.message);
+      })
+  }
+}
+
+
+
+/* Move */
+
+export const WIDGET_MOVE_REQUEST = 'WIDGET_MOVE_REQUEST'
+export const WIDGET_MOVE_FAILURE = 'WIDGET_MOVE_FAILURE'
+
+
+function moveWidgetRequest(position, oldIndex, newIndex) {
+  return {
+    type: WIDGET_MOVE_REQUEST,
+    position, oldIndex, newIndex
+  }
+}
+function moveWidgetFailure(position, oldIndex, newIndex, message) {
+  return {
+    type: WIDGET_MOVE_FAILURE,
+    position, oldIndex, newIndex, message
+  }
+}
+
+export function moveWidget(position, oldIndex, newIndex) {
+  return (dispatch, getState) => {
+    const state = getState();
+    const widgetId = state.entities.widgets[position][oldIndex];
+    const widget = state.entities.widgets.byId[widgetId];
+    console.log("Moving widget", widget.name, "at index", oldIndex, "to", newIndex);
+    dispatch(moveWidgetRequest(position, oldIndex, newIndex));
+    const body = JSON.stringify({index: newIndex});
+    return apiCall(widget.selfUrl, {method: "PUT", body}).then(
+      result => {
+        return dispatch(fetchWidgets());
+      },
+      error => {
+        return dispatch(moveWidgetFailure(position, oldIndex, newIndex, e.message));
+      })
+  }
+}
+
+
+
+/* UI */
+
+export const WIDGET_OPEN_CONFIG = 'WIDGET_OPEN_CONFIG';
+export const WIDGET_CLOSE_CONFIG = 'WIDGET_CLOSE_CONFIG';
+
+export function openConfigDialog(widgetId) {
+  return {
+    type: WIDGET_OPEN_CONFIG,
+    widgetId,
+  }
+}
+
+export function closeConfigDialog(widgetId) {
+  return {
+    type: WIDGET_CLOSE_CONFIG,
+    widgetId,
+  }
+}
diff --git a/hubs/static/client/app/core/actions/widgets.js b/hubs/static/client/app/core/actions/widgets.js
new file mode 100644
index 0000000..4a4abaf
--- /dev/null
+++ b/hubs/static/client/app/core/actions/widgets.js
@@ -0,0 +1,104 @@
+import { apiCall } from '../utils';
+import { addFlashMessage } from './flashMessages';
+
+
+/* GET */
+
+export const HUB_WIDGETS_FETCH_REQUEST = 'HUB_WIDGETS_FETCH_REQUEST'
+export const HUB_WIDGETS_FETCH_SUCCESS = 'HUB_WIDGETS_FETCH_SUCCESS'
+export const HUB_WIDGETS_FETCH_FAILURE = 'HUB_WIDGETS_FETCH_FAILURE'
+
+
+function requestWidgets() {
+  return {
+    type: HUB_WIDGETS_FETCH_REQUEST,
+  }
+}
+
+function receiveWidgets(widgets) {
+  return {
+    type: HUB_WIDGETS_FETCH_SUCCESS,
+    widgets: widgets,
+    receivedAt: Date.now()
+  }
+}
+
+function widgetsRequestFailed() {
+  return {
+    type: HUB_WIDGETS_FETCH_FAILURE,
+  }
+}
+
+
+export function fetchWidgets() {
+  return (dispatch, getState) => {
+    let url = getState().urls.widgets;
+    dispatch(requestWidgets());
+    return apiCall(url).then(
+      widgets => dispatch(receiveWidgets(widgets)),
+      error => {
+        dispatch(addFlashMessage(error.message, "error"));
+        return widgetsRequestFailed();
+      }
+    );
+  }
+}
+
+
+
+/* Get list of widgets */
+
+export const HUB_WIDGETS_AVAIL_REQUEST = 'HUB_WIDGETS_AVAIL_REQUEST';
+export const HUB_WIDGETS_AVAIL_SUCCESS = 'HUB_WIDGETS_AVAIL_SUCCESS';
+export const HUB_WIDGETS_AVAIL_FAILURE = 'HUB_WIDGETS_AVAIL_FAILURE';
+
+function widgetsAvailRequest() {
+  return {
+    type: HUB_WIDGETS_AVAIL_REQUEST,
+  }
+}
+function widgetsAvailSuccess(widgets) {
+  return {
+    type: HUB_WIDGETS_AVAIL_SUCCESS,
+    widgets
+  }
+}
+function widgetsAvailFailure(message) {
+  return {
+    type: HUB_WIDGETS_AVAIL_FAILURE,
+    message
+  }
+}
+
+
+export function getAvailableWidgets() {
+  return (dispatch, getState) => {
+    const state = getState();
+    if (
+      state.entities.availableWidgets.left.length > 0 ||
+      state.entities.availableWidgets.right.length > 0) {
+      return Promise.resolve();  // Already in the cache
+    }
+    let url = state.urls.availableWidgets;
+    dispatch(widgetsAvailRequest());
+    return apiCall(url).then(
+      widgets => {
+        return dispatch(widgetsAvailSuccess(widgets));
+      },
+      error => {
+        dispatch(addFlashMessage(error.message, "error"));
+        return widgetsAvailFailure(error.message);
+      })
+  }
+}
+
+
+/* Edit mode */
+
+export const HUB_WIDGETS_EDIT_MODE = 'HUB_WIDGETS_EDIT_MODE'
+export function setEditMode(editMode) {
+  return {
+    type: HUB_WIDGETS_EDIT_MODE,
+    editMode
+  }
+}
diff --git a/hubs/static/client/app/core/index.js b/hubs/static/client/app/core/index.js
new file mode 100644
index 0000000..a6cbb81
--- /dev/null
+++ b/hubs/static/client/app/core/index.js
@@ -0,0 +1,27 @@
+/* Add the ES6 Promise polyfill because all browsers don't have it yet. */
+import 'babel-polyfill';
+
+import React from 'react';
+import ReactDOM from 'react-dom';
+import { createStore, applyMiddleware } from 'redux';
+import thunk from 'redux-thunk';
+import rootReducer from './reducers';
+import App from "./App";
+
+
+export function setupPage(elementId, initialState) {
+
+  const store = createStore(
+    rootReducer,
+    initialState,
+    applyMiddleware(thunk)
+  );
+  //store.subscribe(() =>
+  //  console.log(store.getState())
+  //)
+  ReactDOM.render(
+    <App store={store} />,
+    document.getElementById(elementId)
+    );
+
+}
diff --git a/hubs/static/client/app/core/reducers/flashMessages.js b/hubs/static/client/app/core/reducers/flashMessages.js
new file mode 100644
index 0000000..ae961a0
--- /dev/null
+++ b/hubs/static/client/app/core/reducers/flashMessages.js
@@ -0,0 +1,24 @@
+import {
+  ADD_FLASH_MESSAGE,
+  CLOSE_FLASH_MESSAGE
+} from '../actions/flashMessages';
+
+
+export default function flashMessages(state=[], action) {
+  switch (action.type) {
+    case ADD_FLASH_MESSAGE:
+      return [
+        ...state,
+        {
+          msg: action.text,
+          type: action.msgType
+        }
+      ];
+    case CLOSE_FLASH_MESSAGE:
+      let stateCopy = state.slice();
+      stateCopy.splice(action.index, 1);
+      return stateCopy;
+    default:
+      return state
+  }
+}
diff --git a/hubs/static/client/app/core/reducers/hub.js b/hubs/static/client/app/core/reducers/hub.js
new file mode 100644
index 0000000..ab788ed
--- /dev/null
+++ b/hubs/static/client/app/core/reducers/hub.js
@@ -0,0 +1,56 @@
+import {
+  HUB_FETCH_REQUEST,
+  HUB_FETCH_SUCCESS,
+  HUB_FETCH_FAILURE,
+  HUB_PUT_REQUEST,
+  HUB_PUT_FAILURE,
+  } from '../actions/hub';
+
+
+export function hubReducer(
+  state={
+    name: null,
+    isLoading: false,
+    old: {},
+  },
+  action
+) {
+  switch (action.type) {
+    case HUB_FETCH_REQUEST:
+      return {
+        ...state,
+        isLoading: true
+      };
+    case HUB_FETCH_SUCCESS:
+      return {
+        ...state,
+        ...action.hub,
+        isLoading: false,
+        old: {}
+      };
+    case HUB_FETCH_FAILURE:
+      return {
+        ...state,
+        isLoading: false
+      };
+    case HUB_PUT_REQUEST:
+      return {
+        ...state,
+        isLoading: true,
+        // Optimistic update
+        config: action.config,
+        users: action.users,
+        old: {config: state.config, users: state.users},
+      };
+    case HUB_PUT_FAILURE:
+      return {
+        ...state,
+        isLoading: false,
+        // Optimism failed... ;-(
+        config: state.old.config,
+        users: state.old.users,
+      };
+    default:
+      return state
+  }
+}
diff --git a/hubs/static/client/app/core/reducers/index.js b/hubs/static/client/app/core/reducers/index.js
new file mode 100644
index 0000000..3d4e9df
--- /dev/null
+++ b/hubs/static/client/app/core/reducers/index.js
@@ -0,0 +1,47 @@
+import { combineReducers } from 'redux';
+import flashMessages from "./flashMessages";
+import sseReducer from "./sse";
+import {
+  hubReducer,
+  hubEditMode
+  } from "./hub";
+import {
+  widgetsReducer,
+  widgetsEditMode,
+  widgetConfigDialogOpen,
+  availableWidgetsReducer,
+  } from "./widgets";
+
+
+const entities = combineReducers({
+  hub: hubReducer,
+  widgets: widgetsReducer,
+  availableWidgets: availableWidgetsReducer,
+});
+
+
+const ui = combineReducers({
+  page: noop,
+  flashMessages,
+  widgetsEditMode,
+  widgetConfigDialogOpen,
+  leftMenu: noop,
+});
+
+
+function noop(state=null, action) {
+  return state;
+}
+
+
+const rootReducer = combineReducers({
+  flashMessages,
+  sse: sseReducer,
+  globalConfig: noop,
+  urls: noop,
+  currentUser: noop,
+  ui,
+  entities,
+});
+
+export default rootReducer;
diff --git a/hubs/static/client/app/core/reducers/sse.js b/hubs/static/client/app/core/reducers/sse.js
new file mode 100644
index 0000000..fb2b7d9
--- /dev/null
+++ b/hubs/static/client/app/core/reducers/sse.js
@@ -0,0 +1,32 @@
+import {
+  SSE_CONNECTED,
+  SSE_DISCONNECTED
+} from '../actions/sse';
+
+
+export default function sseReducer(state={
+  connected: false,
+  readyState: 2
+}, action) {
+  switch (action.type) {
+    case SSE_CONNECTED:
+      if (state.connected) {
+        return state;  // No change
+      }
+      return {
+        connected: true,
+        readyState: action.readyState,
+      };
+    case SSE_DISCONNECTED:
+      if (!state.connected) {
+        return state;  // No change
+      }
+      return {
+        connected: false,
+        readyState: action.readyState,
+      };
+    default:
+      return state
+  }
+}
+
